#include "booster_lite.h"


static cvar_t booster_cvars[] = {
	{"booster_lite_mode", "0", FCVAR_EXTDLL, 0, NULL},
	{"booster_lite_extra_sleep_frequency", "0", FCVAR_EXTDLL, 0, NULL},

	{"booster_lite_version", VVERSION, FCVAR_EXTDLL | FCVAR_SERVER | FCVAR_UNLOGGED, 0, NULL},
	
	{NULL,NULL,0,0,NULL},
};


// Plugin startup.  Register commands and cvars.
void plugin_init(void) 
{
	LOG_MESSAGE(PLID, REALNAME ", " VDATE);		// "Booster vX.XX, X.XX.XXXX (dd.mm.yy)
	LOG_MESSAGE(PLID, "by "VAUTHOR);		// "by Jussi Kivilinna <me@email.to.me>
	LOG_MESSAGE(PLID, "   "VURL);			// "   http://home.page.dot/
	LOG_MESSAGE(PLID, "compiled: " __DATE__ ", " __TIME__ " EET");
	
	
	for(int i = 0; booster_cvars[i].name; i++) CVAR_REGISTER( &booster_cvars[i] );
	
	
	//We set this 10000 .. 
	CVAR_SET_STRING("sys_ticrate", "10000.0");
	
	cvar_booster_lite_mode = CVAR_GET_POINTER("booster_lite_mode");
	cvar_booster_lite_extra_sleep_frequency = CVAR_GET_POINTER("booster_lite_extra_sleep_frequency");
	
	
	//
	//Evil win32 tricks ;)
	//
	if(!ExchangeImport(
		GetModuleHandle(0), //hlds.exe
		(unsigned long)GetProcAddress(GetModuleHandle("kernel32.dll"), "Sleep"), 
		(unsigned long)&NetSleep, 0))
	{
		LogError("ExchangeImport(\"hlds.exe\",\"kernel32.dll\":\"Sleep\",0x%x,0x%x) == 0", (unsigned long)&NetSleep, 0);
	}
	
	if(!ExchangeImport(
		GetModuleHandle("swds.dll"),
		(unsigned long)GetProcAddress(GetModuleHandle("wsock32.dll"), "recvfrom"), 
		(unsigned long)&recvfrom_hook, 0))
	{
		LogError("ExchangeImport(\"swds.dll\",\"wsock32.dll\":\"recvfrom\",0x%x,0x%x) == 0", (unsigned long)&recvfrom_hook, 0);
	}
}


void plugin_fini(void) 
{	
	free_list();
	
	ExchangeImport(
		GetModuleHandle("swds.dll"),
		(unsigned long)&recvfrom_hook, 
		(unsigned long)GetProcAddress(GetModuleHandle("wsock32.dll"), "recvfrom"), 0
	);
	ExchangeImport(
		GetModuleHandle(0), 
		(unsigned long)&NetSleep, 
		(unsigned long)GetProcAddress(GetModuleHandle("kernel32.dll"), "Sleep"), 0
	);
}


